/* Dieses Programm liest eine Sudoku-Puzzle von der Standard-Eingabe ein
   und gibt eine Formel der Aussagenlogik aus. Diese beschreibt das
   eingelesene Puzzle, aber die Sudoku-Regeln werden noch nicht korrekt
   beschrieben. Ihre Aufgabe ist es, Letzteres zu beheben. */

#include <stdio.h>

/****************************************************************************/

/* FELDER bestimmt die Dimension des Sudoku-Puzzles.
   2 bedeutet 4x4, 3 bedeutet 9x9 usf. */
#define FELDER 3
#define DIM (FELDER*FELDER)

/****************************************************************************/

int spalte, zeile, zahl;
int feldx, feldy, subfeldx, subfeldy;

int zeiger;
char bedingung[DIM][50];

/****************************************************************************/

/* Die folgenden drei Prozeduren sind vielleicht fr Sie hilfreich:
   * neue_diskunktion() initialisiert ein Array, in das man genau
     neun Variablen eintragen kann.
   * generiere_variable() fgt dem Array eine Variable hinzu, nmlich
	v_x_y_z, wobei x=zeile, y=spalte und z=zahl sind.
   * schreibe_bedingung() erzeugt eine Disjunktion aus den neun Variablen
     im Array.								   */
   
void neue_disjunktion ()
{
	zeiger = 0;
}

void generiere_variable ()
{
	sprintf(bedingung[zeiger++],"v_%d_%d_%d",zeile,spalte,zahl);
}

void schreibe_disjunktion ()
{
	int i;
	printf("& (%s",bedingung[0]);
	for (i = 1; i < DIM; i++)
		printf(" | %s",bedingung[i]);
	printf(")\n");
}

/****************************************************************************/

int main ()
{
	printf("dummy\n");	/* Das hier dient nur der korrekten Syntax. */

	/* Hier wird ein Puzzle von der Standard-Eingabe gelesen, und die
	   vorbelegten Felder durch eine Formel reprsentiert (die Formel G
	   in der Aufgabe). */
	for (zeile = 1; zeile <= DIM; zeile++)
	    for (spalte = 1; spalte <= DIM; spalte++)

		{
			scanf("%d",&zahl);
			if (zahl) printf("& v_%d_%d_%d\n",zeile,spalte,zahl);
		}

	/* Folgender Code-Block erzeugt die Formel F der Aufgabenstellung
	   (in Zeile 1 muss jede Zahl vorkommen). Ergnzen Sie diesen Teil
	   des Programms so, dass die Formel F' herauskommt, die alle
	   Sudoku-Regeln korrekt beschreibt. */

	zeile = 1;
	for (zahl = 1; zahl <= DIM; zahl++)
	{
		neue_disjunktion();
		for (spalte = 1; spalte <= DIM; spalte++)
			generiere_variable();
		schreibe_disjunktion();
	}

	return 0;
}
